
CoCoALib - Feature #72

Feature # 68 (Closed): cleanup doc for matrix, MatrixViews, *Matrix*,....

MatByRows, MatByCols

21 Dec 2011 17:50 - John Abbott

Status: Closed Start date: 21 Dec 2011

Priority: Low Due date:  

Assignee: John Abbott % Done: 100%

Category: New Function Estimated time: 5.00 hours

Target version: CoCoALib-0.99534 Seoul14 Spent time: 4.10 hours

Description

CoCoA4 has MakeMatByRows and MakeMatByCols.

Should CoCoALib offer MatrixViews which in an analogous way?

If so, what should the pseudo-ctors be called?  MatByRows, MatByCols.

Strictly it is redundant having both as transpose(MatByRows(vec)) is MatByCols(vec)

History

#1 - 21 Dec 2011 18:02 - John Abbott

Even if we decide not to create MatByRows/MatByCols we should mention it in the documentation (e.g. under Shortcomings, etc)

#2 - 28 Mar 2013 17:06 - John Abbott

- Category set to New Function

- Priority changed from Normal to High

- Target version set to CoCoALib-0.9953

JAA notes that there is a ctor for DenseMat which behaves as MatByRows except that it makes a copy of the entries.

Advantages of MatByRows and MatByCols:

does not copy the elements (so should be fast)

the impl is easy/fast (in fact I have already done most of it)

Disadvantages:

uses a reference internally so there is a risk of a dangling reference with incautious use

might be confusing given that there is a NewDenseMat ctor which works similarly to MatByRows (but we could easily eliminate that ctor,

replacing a call to it by a call of the form NewDenseMat(MatByRows(...)))

NB I have increased priority in the hope that we can settle this issue shortly.

#3 - 29 May 2013 12:22 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott
- Priority changed from High to Low

- Target version changed from CoCoALib-0.9953 to CoCoALib-0.99534 Seoul14

- % Done changed from 0 to 20

JAA now thinks it is better to offer both MatByRows and MatByCols so that user code is more readable (& expresses more clearly the programmers

intent).  Of course, internally the implementation of MatByCols could simply be a transpose of a MatByRows...

Since this is not needed for the upcoming CoCoA summer school, I'm delaying "delivery" until 0.9954.

#4 - 29 Oct 2013 15:15 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#5 - 01 Apr 2014 19:26 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#6 - 08 Apr 2014 18:41 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#7 - 16 Jul 2014 14:57 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 20 to 90

The code is already there (and has been for how long?)  Fns are MatByRows and MatByCols.

I added some documentation.  I might add an example (if there isn't already one).

Note: there is also a commented out signature with arg vector<vector<RingElem>>.

#8 - 16 Jul 2014 16:01 - Anna Maria Bigatti

should we rename the CoCoA-5 functions MakeMatByRows?

(and move the "Make.." into obsolescent?)

#9 - 16 Jul 2014 16:18 - John Abbott

Not yet entirely convinced about renaming MakeMatByRows.  It is very similar to MatByRows but there is an important difference: the C5 fns do

make copies.  Perhaps it does not matter that much -- after all the MakeMatByXXX fns are essentially never called in the packages!

Christof is undecided.  He wondered whether it'd be better to include the word View in the CoCoALib fns.

#10 - 17 Jul 2014 16:39 - John Abbott

The impl for MatByCols was missing; it is there now (quick cut-and-paste job).

Also added an example.

Not closing because of the question in the previous comment about the name (e.g. MatViewByRows as Christof suggested).

#11 - 31 Jul 2014 14:54 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

Christof has a valid point about the mnemonic value of including view in the name, but Anna points out that none of the other matrix view

pseudo-ctors contains view in the name.  Adding View would make all the names longer, an aspect we do not like. So we reject Christof's idea (for the

moment); but we will reconsider if problems arise often enough that changing name would be a good idea.

Closing.
